﻿<%@ Page Language="C#" AutoEventWireup="false" CodeBehind="View.aspx.cs" Inherits="CheckboxWeb.Forms.Surveys.Responses.View" MasterPageFile="~/Dialog.Master" %>
<%@ Import Namespace="Checkbox.Common" %>
<%@ Import Namespace="Checkbox.Forms" %>
<%@ Import Namespace="Checkbox.Forms.Items" %>
<%@ Import Namespace="Checkbox.Globalization" %>
<%@ Import Namespace="Checkbox.Management" %>
<%@ Import Namespace="Checkbox.Web" %>
<%@ Import Namespace="Checkbox.Web.UI.Controls" %>
<%@ MasterType VirtualPath="~/Dialog.Master" %>

<asp:Content ID="_script" runat="server" ContentPlaceHolderID="_headContent">
 <script type="text/javascript">
     var dateFormat = '<%=GlobalizationManager.GetDateFormat().ToLowerInvariant()%>';
     var timeFormat = '<%=GlobalizationManager.GetTimeFormat().ToUpperInvariant()%>';

     $(function () {
         $('.serverDate').each(function (idx, el) {
             var dateString = $(el).text();
             dateString = $.trim(dateString);
             if (dateString != '<%= WebTextManager.GetText("/pageText/viewResponseDetails.aspx/notAvailable")%>') {
                 var d = new Date(dateString);
                 $(el).text($.localize(d, dateFormat) + ' ' + $.localize(d, timeFormat));
             }
         });

         if (typeof (setViewResponsePagination) == 'function') {
             setViewResponsePagination();
         }
         //hide all embedded download links, they are don't work in a dialog
         $('.uploadedFileLink').hide();
     });
     
     function doDownload(answerId) {
         UFrameManager.prepareOuterFormSubmit();
         
         $('#aspnetForm #__EVENTTARGET').attr('value','downloadFile');
         $('#aspnetForm #__EVENTARGUMENT').attr('value', answerId);
         $('#aspnetForm').submit();
     }

     function toggleDashSection(item, id) {
         if ($('#' + id).is(':visible')) {
             $(item).removeClass('pageArrowUp');
             $(item).addClass('pageArrowDown');
             $('#' + id).hide('blind', null, 'fast');
         } else {
             $(item).removeClass('pageArrowDown');
             $(item).addClass('pageArrowUp');
             $('#' + id).show('blind', null, 'fast');
         }
     }
    </script>

    <% if (PrintMode != ExportMode.None) { %>
    <style>
        body {
            overflow-x: visible !important;
            overflow-y: visible !important;
        }
    </style>
    <script language="javascript">
        $(document).ready(
            function () {
                window.print();
            });
    </script>
    <%}; %>
</asp:Content>

<asp:Content ID="_content" runat="server" ContentPlaceHolderID="_pageContent">
    <asp:Panel ID="_responseContent" CssClass="padding10" runat="server">
        <asp:Panel ID="_editResponsePlace" runat="server">
            <a class="ckbxButton roundedCorners border999 shadow999 orangeButton" uframeignore="_true" target="_blank" href="#" id="_editLink" runat="server" visible="false"><%=WebTextManager.GetText("/controlText/forms/surveys/controls/previewControls.ascx/editResponse")%></a>
            <a style="margin-left: 5px;" class="ckbxButton silverButton" uframeignore="_true" id="_printLink" runat="server" target="_blank">Print Response</a>
        </asp:Panel>
        <asp:Panel ID="_responseInfoPanel" runat="server">
            <div class="dashStatsWrapper border999 shadow999">
                <div class="dashStatsHeader">
                    <span class="mainStats left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/responseInformation")%></span>
                    <span id="surveyStatusToggle" class="pageArrowUp" onclick="toggleDashSection(this, 'responseInfoContainer');">&nbsp;</span>
                </div>
                <div id="responseInfoContainer">
                    <div class="dashStatsContent zebra">
                        <div class="fixed_75 left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/timeStarted")%></div>
                        <div class="left"><b class="serverDate">
                            <%= ResponseDateCreatedOnClientSide.HasValue 
                                ?ResponseDateCreatedOnClientSide.Value.ToUniversalTime().ToString("yyyy-MM-ddTHH:mm:ssZ")
                                : WebTextManager.GetText("/pageText/viewResponseDetails.aspx/notAvailable") %></b>
                        </div>
                        <br class="clear" />
                    </div>
                    <div class="dashStatsContent detailZebra">
                        <div class="fixed_75 left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/timeCompleted")%></div>
                        <div class="left"><b class="serverDate">
                            <%= ResponseDateCompletedOnClientSide.HasValue
                                ? ResponseDateCompletedOnClientSide.Value.ToUniversalTime().ToString("yyyy-MM-ddTHH:mm:ssZ")
                                : WebTextManager.GetText("/pageText/viewResponseDetails.aspx/notAvailable") %></b>
                        </div>
                        <br class="clear" />
                    </div>
                    <div class="dashStatsContent zebra">
                        <div class="fixed_75 left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/lastEdited")%></div>
                        <div class="left"><b class="serverDate">
                            <%= ResponseDateLastModifiedOnClientSide.HasValue
                                ? ResponseDateLastModifiedOnClientSide.Value.ToUniversalTime().ToString("yyyy-MM-ddTHH:mm:ssZ")
                                : WebTextManager.GetText("/pageText/viewResponseDetails.aspx/notAvailable") %></b>
                        </div>
                        <br class="clear" />
                    </div>
                    <div class="dashStatsContent detailZebra">
                        <div class="fixed_75 left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/totalTime")%></div>
                        <div class="left"><b>
                            <%= CurrentResponse.DateCompleted.HasValue  && CurrentResponse.DateCreated.HasValue
                                ? CurrentResponse.DateCompleted.Value.Subtract(CurrentResponse.DateCreated.Value).ToString()
                                : string.Empty %></b>
                        </div>
                        <br class="clear" />
                    </div>
                    <div class="dashStatsContent zebra">
                        <div class="fixed_75 left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/isTest")%></div>
                        <div class="left"><b>
                            <%= WebTextManager.GetText(CurrentResponse.IsTest? "/common/yes" : "/common/no")%></b>
                        </div>
                        <br class="clear" />
                    </div>
                    <% if(ApplicationManager.AppSettings.LogIpAddresses) {%>
                    <div class="dashStatsContent detailZebra">
                        <div class="fixed_75 left"><%=WebTextManager.GetText("/pageText/viewResponses.aspx/ipAddress")%>:</div>
                        <div class="left"><b>
                            <%= CurrentResponse.IPAddress %>
                            </b>
                        </div>
                        <br class="clear" />
                    </div>
                    <%} %>
                    <asp:PlaceHolder ID="_scorePlace" runat="server">
                        <div class="dashStatsContent zebra">
                            <div class="fixed_75 left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/totalScore")%></div>
                            <div class="left"><b><%= CurrentResponse.TotalScore.HasValue ? CurrentResponse.TotalScore.ToString() : string.Empty %></b></div>
                            <br class="clear" />
                        </div>
                    </asp:PlaceHolder>
                </div>
            </div>
        </asp:Panel>

    <asp:Panel ID="_userInfoPanel" runat="server">
        <div class="dashStatsWrapper border999 shadow999">
            <div class="dashStatsHeader">
                <span class="mainStats left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/userInformation")%></span>
                <span id="userInfoToggle" class="pageArrowUp" onclick="toggleDashSection(this, 'userInfoContainer');">&nbsp;</span>
            </div>
            <div id="userInfoContainer">
                <div class="dashStatsContentHeader">Login Info</div>
                <div class="dashStatsContent zebra">
                    <div class="fixed_75 left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/userName")%>:</div>
                    <div class="left"><b><%= CurrentResponse.UniqueIdentifier %></b></div>
                    <br class="clear" />
                </div>
                <div class="dashStatsContent detailZebra">
                    <div class="fixed_75 left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/invitee")%>:</div>
                    <div class="left"><b><%= CurrentResponse.Invitee %></b></div>
                    <br class="clear" />
                </div>
                <asp:PlaceHolder ID="_networkUserPlace" runat="server">
                    <div class="dashStatsContent detailZebra">
                        <div class="fixed_75 left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/networkUser")%>:</div>
                        <div class="left"><b><%= CurrentResponse.NetworkUser %></b></div>
                        <br class="clear" />
                    </div>
                </asp:PlaceHolder>
            
                <!--
                <ul class="dashStatsContent allMenu">
                    <li class="fixed_75 left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/invitee")%></li>
                    <li></li>
                    <br class="clear" />
                </ul> -->

                <asp:PlaceHolder ID="_userPropertiesPlace" runat="server">
                    <asp:Repeater ID="_userPropertiesRepeater" runat="server">
                        <HeaderTemplate>
                            <div class="dashStatsContentHeader">User Profile</div>
                        </HeaderTemplate>
                        <ItemTemplate>
                            <div class="dashStatsContent zebra">
                                <div class="fixed_100 left"><%# DataBinder.Eval(Container.DataItem, "Key") %>:</div>
                                <div class="left"><b><%# DataBinder.Eval(Container.DataItem, "Value") %></b></div>
                                <br class="clear" />
                            </div>
                        </ItemTemplate>
                        <AlternatingItemTemplate>
                            <div class="dashStatsContent detailZebra">
                                <div class="fixed_100 left"><%# DataBinder.Eval(Container.DataItem, "Key") %>:</div>
                                <div class="left"><b><%# DataBinder.Eval(Container.DataItem, "Value") %></b></div>
                                <br class="clear" />
                            </div>
                        </AlternatingItemTemplate>
                    </asp:Repeater>
                </asp:PlaceHolder>
            </div>
        </div>
    </asp:Panel>
  
        <div class="dashStatsWrapper border999 shadow999">
            <div class="dashStatsHeader">
                <span class="mainStats left"><%=WebTextManager.GetText("/pageText/viewResponseDetails.aspx/responseDetails")%></span>
            </div>

            <asp:Repeater ID="_pageRepeater" runat="server" OnItemCreated="pageRepeaterItemCreated">
                <ItemTemplate>
                    <% if (ShowPageNumbers)
                       { %> <div class="viewResponsePageHeader" style="font-size:16px;"><%#GetPageTitle(Container.DataItem as ResponsePage) %></div> <%} %>

                    <asp:Repeater ID="_itemRepeater" runat="server" OnItemCreated="itemRepeaterItemCreated">
                        <HeaderTemplate>
                            <table>
                        </HeaderTemplate>
                        <ItemTemplate>
                            <tr>
                                <td class="viewResponseTD">
                                    <div class="viewResponseQuestion fixed_25"><p><strong><%# GetItemNumber(Container.DataItem as Item) %> - </strong></p></div>
                                </td>
                                <td class="viewResponseTD">
                                    <div class="left"><%# GetItemHtml(Container.DataItem as Item).Replace("><&nbsp;<", ">&lt;<") %><asp:Panel ID="_uploadedItemsPlace" runat="server"></asp:Panel></div>
                                </td>
                            </tr>
                        </ItemTemplate>
                        <FooterTemplate>
                            </table>
                        </FooterTemplate>
                    </asp:Repeater>
                </ItemTemplate>
            </asp:Repeater>
        </div>
    </asp:Panel>

    <script type="text/javascript">
        if(typeof(resizePanels) == 'function') {
            resizePanels();
        }
    </script>
</asp:Content>

<script type="text/C#" runat="server">
    /// <summary>
    /// 
    /// </summary>
    /// <param name="page"></param>
    /// <returns></returns>
    protected string GetPageTitle(ResponsePage page)
    {
        if (page == null)
        {
            return string.Empty;
        }
        
        if (page.PageType == TemplatePageType.HiddenItems)
        {
            return WebTextManager.GetText("/pageText/viewResponseDetails.aspx/hiddenItems");
        }

        var pageScoreString = string.Empty;

        if (ResponseTemplate.BehaviorSettings.EnableScoring && page.PageType == TemplatePageType.ContentPage)
        {
            var pageScore = page.Items.Where(item => item is IScored).Sum(item => ((IScored) item).GetScore());

            pageScoreString = string.Format("&nbsp;({0})", pageScore);
        }
        
        //Subtract 1 from page position to account for hidden items at page 1
        return string.Format("{0} {1}{2}", WebTextManager.GetText("/pageText/viewResponseDetails.aspx/page"), page.Position  - 1, pageScoreString);
    }
    
    /// <summary>
    /// 
    /// </summary>
    /// <param name="item"></param>
    /// <returns></returns>
    protected string GetItemNumber(Item item)
    {
         var answerableItem = item as IAnswerable;
        
        if(answerableItem == null || !answerableItem.HasAnswer)
        {
            return string.Empty;
        }

        var itemNumber = CurrentResponse.GetItemNumber(item.ID);

        return itemNumber.HasValue ? itemNumber.ToString() : string.Empty;
    }
    
    /// <summary>
    /// 
    /// </summary>
    /// <param name="item"></param>
    /// <returns></returns>
    protected string GetItemHtml(Item item)
    {
        var answerableItem = item as IAnswerable;

        if ((answerableItem == null && !(item is Message) && !(item is ImageItem) && !(item is HtmlItem)) ||
            (answerableItem != null && !answerableItem.HasAnswer))
        {
            return string.Empty;
        }

        //Add HTML for the item                                                
        IItemFormatter itemFormatter = GetItemFormatter(item.TypeID);

        if (itemFormatter == null)
            return string.Empty;

        return Utilities.EncodeTagsInHtmlContent(itemFormatter.Format(item, "html", ResponseTemplate.BehaviorSettings.EnableScoring));
    }
       
    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void pageRepeaterItemCreated(object sender, RepeaterItemEventArgs e)
    {
        if(e.Item == null || e.Item.DataItem == null)
        {
            return;
        }
        
        var itemRepeater = e.Item.FindControl("_itemRepeater") as Repeater;

        if (itemRepeater == null)
        {
            return;
        }
        
        itemRepeater.DataSource =
            ((ResponsePage) e.Item.DataItem)
                .Items
                .Where(it => (it is IAnswerable && ((IAnswerable)it).HasAnswer) || (IncludeMessageItems && (it is ImageItem || it is Message || it is HtmlItem)));
        itemRepeater.DataBind();
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void itemRepeaterItemCreated(object sender, RepeaterItemEventArgs e)
    {
        //Handle upload item file downloads, if necessary
        if (e.Item == null || e.Item.DataItem == null || e.Item.DataItem as UploadItem == null)
        {
            return;
        }

        var uploadItemPlace = e.Item.FindControl("_uploadedItemsPlace") as Panel;

        if (uploadItemPlace == null)
        {
            return;
        }

        var uploadItem = e.Item.DataItem as UploadItem;
        
        //<btn:CheckboxButton ID="_exportLanguageNamesBtn" runat="server" returnfile="true" CssClass="ckbxButton roundedCorners border999 shadow999 orangeButton" TextId="/pageText/settings/languageNames.aspx/exportToXml"/>
        foreach (long answerId in uploadItem.GetAllAnswerIds())
        {
            var downloadFile = new MultiLanguageLinkButton
                                   {
                                       ID = "DownloadFile" + answerId,
                                       CommandName = "AnswerID",
                                       TextId = "/pageText/viewResponseDetails.aspx/downloadFile",
                                       Text = "Download File",
                                       CommandArgument = answerId.ToString()
                                   };
            downloadFile.Attributes["href"] = "javascript:doDownload(" + answerId + ")";
            uploadItemPlace.Controls.Add(downloadFile);
        }
    }
</script>